<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html><head><meta http-equiv="Content-Type" content="text/html;charset=iso-8859-1">
<title>iPcMesh Struct Reference (CEL: Crystal Entity Layer 2.0 Public API Reference)</title>
<link href="tabs.css" rel="stylesheet" type="text/css">
<link href="doxygen.css" rel="stylesheet" type="text/css">
</head><body>
<table border="0" cellpadding="0" cellspacing="0" width="100%" class="head">
 <tr height="59">
  <td class="head" width="202" valign="bottom" style="padding-left:0;"><a href="http://cel.crystalspace3d.org/"><img src="celblur.png" width="210" height="59" alt="CEL" border="0"></a></td>
  <td class="head"><h2>Public API Reference</h2></td>
 </tr>
 <tr height="11">
  <td colspan="2" class="headshadow" valign="top" style="padding-left:0;"><img src="celshadow.png" width="9" height="11" alt="" border="0"></td>
 </tr>
</table>
<div class="content">
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="hierarchy.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a>  </div>
  <div class="headertitle">
<div class="title">iPcMesh Struct Reference</div>  </div>
</div><!--header-->
<div class="contents">
<!-- doxytag: class="iPcMesh" --><!-- doxytag: inherits="iBase" -->
<p>This is a property class holding the representation of a mesh.  
 <a href="structiPcMesh.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="mesh_8h_source.html">propclass/mesh.h</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for iPcMesh:</div>
<div class="dyncontent">
 <div class="center">
  <img src="structiPcMesh.png" usemap="#iPcMesh_map" alt=""/>
  <map id="iPcMesh_map" name="iPcMesh_map">
<area doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiBase.html" alt="iBase" shape="rect" coords="0,0,61,24"/>
</map>
 </div></div>

<p><a href="structiPcMesh-members.html">List of all members.</a></p>
<table class="memberdecls">
<tr><td colspan="2"><h2><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcMesh.html#a5c261a8a5cf3cf6d64ce81d5ba3c2a71">AttachSocketMesh</a> (const char *socket, <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiMeshWrapper.html">iMeshWrapper</a> *meshwrapper)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Attach mesh to a socket.  <a href="#a5c261a8a5cf3cf6d64ce81d5ba3c2a71"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcMesh.html#a000b6c012847f278c3cfe83ba0403265">CreateEmptyGenmesh</a> (const char *factname)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Create an empty genmesh (use instead of <a class="el" href="structiPcMesh.html#a2ab3432fdc392c0efc5b15a92a24c084" title="Set the mesh filename to use.">SetMesh()</a>).  <a href="#a000b6c012847f278c3cfe83ba0403265"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcMesh.html#a80337a27e39f25c7975d74d2f2f08189">CreateEmptyThing</a> (const char *factname)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Create an empty thing mesh (use instead of <a class="el" href="structiPcMesh.html#a2ab3432fdc392c0efc5b15a92a24c084" title="Set the mesh filename to use.">SetMesh()</a>).  <a href="#a80337a27e39f25c7975d74d2f2f08189"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcMesh.html#a94fb201424dcdb38989b3019875601c2">CreateNullMesh</a> (const char *factname, const <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsBox3.html">csBox3</a> &amp;box)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Create a nullmesh (use instead of <a class="el" href="structiPcMesh.html#a2ab3432fdc392c0efc5b15a92a24c084" title="Set the mesh filename to use.">SetMesh()</a>).  <a href="#a94fb201424dcdb38989b3019875601c2"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcMesh.html#a32a6f0872aa789f15c60c89daeeec4cb">DetachSocketMesh</a> (const char *socket)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Detach mesh from a socket.  <a href="#a32a6f0872aa789f15c60c89daeeec4cb"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual const char *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcMesh.html#a6ce41a2869d0c29b735c2fad34ab251e">GetAction</a> ()=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Return the current action name.  <a href="#a6ce41a2869d0c29b735c2fad34ab251e"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiMeshWrapper.html">iMeshWrapper</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcMesh.html#aaf7a92f71dcc5c54f1fd0e294c17a7bd">GetMesh</a> () const =0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the mesh.  <a href="#aaf7a92f71dcc5c54f1fd0e294c17a7bd"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcMesh.html#a27433c8c059562f24f77b7f2dbba902b">Hide</a> ()=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Hide this mesh.  <a href="#a27433c8c059562f24f77b7f2dbba902b"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcMesh.html#a9a5048289df31d088e40f0a1c4d40771">IsVisible</a> () const =0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Return true if mesh is visible.  <a href="#a9a5048289df31d088e40f0a1c4d40771"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcMesh.html#a6e829a0c7fc5f2fa2c3f960793e31d7f">MoveMesh</a> (<a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiSector.html">iSector</a> *sector, const <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a> &amp;pos)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Convenience function to move the mesh to some sector and position and also update lighting.  <a href="#a6e829a0c7fc5f2fa2c3f960793e31d7f"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcMesh.html#a2562f38328a7bf1e5ad6decb8aa63fd0">MoveMesh</a> (<a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiSector.html">iSector</a> *sector, const char *node)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Convenience function to move the mesh to some sector and node and also update lighting.  <a href="#a2562f38328a7bf1e5ad6decb8aa63fd0"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcMesh.html#a190afeaf6e815f1f1c3e305ccd916b10">MoveMesh</a> (<a class="el" href="structiPcMesh.html">iPcMesh</a> *other_mesh, const <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a> &amp;offset)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Convenience function to move the mesh to a position relative to some other mesh, and also update lighting.  <a href="#a190afeaf6e815f1f1c3e305ccd916b10"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcMesh.html#a1e85edbbe5f2d9b1918a2153afc54990">SetAction</a> (const char *actionName, bool reset=false)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Convenience function to set an 'action' for the mesh.  <a href="#a1e85edbbe5f2d9b1918a2153afc54990"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcMesh.html#a2ebf79681aa9fafa6e9fafdc1e8b42b2">SetAnimation</a> (const char *actionName, bool cycle, float weight=1.0, float fadein=0.1, float fadeout=0.1, bool reset=false)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Function to set an 'action' for the mesh.  <a href="#a2ebf79681aa9fafa6e9fafdc1e8b42b2"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcMesh.html#a2ab3432fdc392c0efc5b15a92a24c084">SetMesh</a> (const char *factname, const char *filename)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Set the mesh filename to use.  <a href="#a2ab3432fdc392c0efc5b15a92a24c084"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcMesh.html#aeb16f4efc93224b58d8cbc5b52c981b4">SetMesh</a> (<a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiMeshWrapper.html">iMeshWrapper</a> *mesh, bool do_remove=false)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Set the mesh to use directly.  <a href="#aeb16f4efc93224b58d8cbc5b52c981b4"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcMesh.html#a91fc60c23d84087bfccfe0f76f649189">SetPath</a> (const char *path)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Set the path to use.  <a href="#a91fc60c23d84087bfccfe0f76f649189"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcMesh.html#a1dd7280f6eb19bfcfafb47e098b86182">SetReverseAction</a> (bool reverse=true)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Convenience function to set an 'action' to be reversed for the mesh.  <a href="#a1dd7280f6eb19bfcfafb47e098b86182"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcMesh.html#a63106a14cd825a75e85ff00e2cd8e3a9">Show</a> ()=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Show this mesh.  <a href="#a63106a14cd825a75e85ff00e2cd8e3a9"></a><br/></td></tr>
</table>
<hr/><a name="details" id="details"></a><h2>Detailed Description</h2>
<div class="textblock"><p>This is a property class holding the representation of a mesh. </p>
<p>This property class supports the following actions (add prefix 'cel.mesh.action.' if you want to access this action through a message):</p>
<ul>
<li>SetMesh: parameters 'name' (string). This sets an already existing mesh for this pcmesh and sets property 'meshname'.</li>
<li>LoadMesh: parameters 'filename' (string) and 'factoryname' (string). 'filename' is optional. If not given then the factory should already be in memory and sets properties 'factory' and 'filename'.</li>
<li>LoadMeshPath: parameters 'path' (string), 'filename' (string) and 'factoryname' (string) and sets properties 'factory', 'path' and 'filename'.</li>
<li>MoveMesh: parameters 'sector' (string: optional), 'position' (vector3) or 'position' (string: represents name of the node), 'rotation' (vector3: optional. Represents an absolute rotation). If 'sector' is empty string then we will remove the mesh from all sectors. If 'sector' is not given then we simply move the mesh inside current sector.</li>
<li>RotateMesh: 'rotation' (vector3). This is a relative transform.</li>
<li>ClearRotation: no parameters.</li>
<li>LookAt: parameters 'forward' (vector3) and 'up' (vector3).</li>
<li>SetVisible: parameters 'visible' (bool).</li>
<li>SetMaterial: parameters 'material' (string).</li>
<li>SetAnimation: parameters 'animation' (string), 'cycle' (bool: default false), and 'reset' (bool: default false).</li>
<li>SetShaderVar: parameters 'name' (string), 'type' (string) and 'value' (type depending on type parameter). Supported types are: 'float', 'long', 'vector3' and 'libexpr'.</li>
<li>CreateEmptyThing: parameters 'factoryname' (string)</li>
<li>CreateEmptyGenmesh: parameters 'factoryname' (string)</li>
<li>CreateNullMesh: parameters 'factoryname' (string), 'min' (vector3), 'max' (vector3).</li>
<li>ParentMesh: parameters 'entity' (string) and 'tag' (string). Parent this mesh to some parent. The parent should be given as an entity with the optional tag specifying which pcmesh to use. If entity is not given then the current entity will be used.</li>
<li>ClearParent: no parameters. Remove this mesh from its parent.</li>
<li>AttachSocketMesh: parameters 'socket', 'factory' (string) or 'object' (string)</li>
<li>DetachSocketMesh: parameters 'socket'</li>
</ul>
<p>This property class supports the following properties:</p>
<ul>
<li>position (vector3, read): current position.</li>
<li>fullposition (vector3, read): current full position.</li>
<li>rotation (vector3, read): current rotation.</li>
<li>eulerrotation (vector3, read): current euler rotation.</li>
<li>sector (string, read): current sector.</li>
<li>path (string, read): path for model.</li>
<li>factory (string, read): factory for model.</li>
<li>filename (string, read): filename for model.</li>
<li>meshname (string, read): mesh object name for model.</li>
<li>hitbeam (bool, read/write): allow hitbeam for this mesh. </li>
</ul>

<p>Definition at line <a class="el" href="mesh_8h_source.html#l00092">92</a> of file <a class="el" href="mesh_8h_source.html">mesh.h</a>.</p>
</div><hr/><h2>Member Function Documentation</h2>
<a class="anchor" id="a5c261a8a5cf3cf6d64ce81d5ba3c2a71"></a><!-- doxytag: member="iPcMesh::AttachSocketMesh" ref="a5c261a8a5cf3cf6d64ce81d5ba3c2a71" args="(const char *socket, iMeshWrapper *meshwrapper)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool <a class="el" href="structiPcMesh.html#a5c261a8a5cf3cf6d64ce81d5ba3c2a71">iPcMesh::AttachSocketMesh</a> </td>
          <td>(</td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>socket</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiMeshWrapper.html">iMeshWrapper</a> *&#160;</td>
          <td class="paramname"><em>meshwrapper</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Attach mesh to a socket. </p>
<p>Only one mesh per socket. Support for genmesh, cal3d and sprite3d. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">socket</td><td>Name of the socket. </td></tr>
    <tr><td class="paramname">factory</td><td>Name of the loaded mesh factory. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a000b6c012847f278c3cfe83ba0403265"></a><!-- doxytag: member="iPcMesh::CreateEmptyGenmesh" ref="a000b6c012847f278c3cfe83ba0403265" args="(const char *factname)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiPcMesh.html#a000b6c012847f278c3cfe83ba0403265">iPcMesh::CreateEmptyGenmesh</a> </td>
          <td>(</td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>factname</em></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Create an empty genmesh (use instead of <a class="el" href="structiPcMesh.html#a2ab3432fdc392c0efc5b15a92a24c084" title="Set the mesh filename to use.">SetMesh()</a>). </p>
<p>Note that if the factory name already exists then the mesh will be created from that factory and this call becomes equivalent to SetMesh(factname,0). </p>

</div>
</div>
<a class="anchor" id="a80337a27e39f25c7975d74d2f2f08189"></a><!-- doxytag: member="iPcMesh::CreateEmptyThing" ref="a80337a27e39f25c7975d74d2f2f08189" args="(const char *factname)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiPcMesh.html#a80337a27e39f25c7975d74d2f2f08189">iPcMesh::CreateEmptyThing</a> </td>
          <td>(</td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>factname</em></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Create an empty thing mesh (use instead of <a class="el" href="structiPcMesh.html#a2ab3432fdc392c0efc5b15a92a24c084" title="Set the mesh filename to use.">SetMesh()</a>). </p>
<p>After this use <a class="el" href="structiPcMesh.html#aaf7a92f71dcc5c54f1fd0e294c17a7bd" title="Get the mesh.">GetMesh()</a> to add polygons to the mesh. Note that if the factory name already exists then the mesh will be created from that factory and this call becomes equivalent to SetMesh(factname,0). </p>

</div>
</div>
<a class="anchor" id="a94fb201424dcdb38989b3019875601c2"></a><!-- doxytag: member="iPcMesh::CreateNullMesh" ref="a94fb201424dcdb38989b3019875601c2" args="(const char *factname, const csBox3 &amp;box)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiPcMesh.html#a94fb201424dcdb38989b3019875601c2">iPcMesh::CreateNullMesh</a> </td>
          <td>(</td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>factname</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsBox3.html">csBox3</a> &amp;&#160;</td>
          <td class="paramname"><em>box</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Create a nullmesh (use instead of <a class="el" href="structiPcMesh.html#a2ab3432fdc392c0efc5b15a92a24c084" title="Set the mesh filename to use.">SetMesh()</a>). </p>
<p>Note that if the factory name already exists then the mesh will be created from that factory and this call becomes equivalent to SetMesh(factname,0). A nullmesh can be used in mesh hierarchies. </p>

</div>
</div>
<a class="anchor" id="a32a6f0872aa789f15c60c89daeeec4cb"></a><!-- doxytag: member="iPcMesh::DetachSocketMesh" ref="a32a6f0872aa789f15c60c89daeeec4cb" args="(const char *socket)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool <a class="el" href="structiPcMesh.html#a32a6f0872aa789f15c60c89daeeec4cb">iPcMesh::DetachSocketMesh</a> </td>
          <td>(</td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>socket</em></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Detach mesh from a socket. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">socket</td><td>Name of the socket. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a6ce41a2869d0c29b735c2fad34ab251e"></a><!-- doxytag: member="iPcMesh::GetAction" ref="a6ce41a2869d0c29b735c2fad34ab251e" args="()=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual const char* <a class="el" href="structiPcMesh.html#a6ce41a2869d0c29b735c2fad34ab251e">iPcMesh::GetAction</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Return the current action name. </p>

</div>
</div>
<a class="anchor" id="aaf7a92f71dcc5c54f1fd0e294c17a7bd"></a><!-- doxytag: member="iPcMesh::GetMesh" ref="aaf7a92f71dcc5c54f1fd0e294c17a7bd" args="() const =0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiMeshWrapper.html">iMeshWrapper</a>* <a class="el" href="structiPcMesh.html#aaf7a92f71dcc5c54f1fd0e294c17a7bd">iPcMesh::GetMesh</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const<code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Get the mesh. </p>

</div>
</div>
<a class="anchor" id="a27433c8c059562f24f77b7f2dbba902b"></a><!-- doxytag: member="iPcMesh::Hide" ref="a27433c8c059562f24f77b7f2dbba902b" args="()=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiPcMesh.html#a27433c8c059562f24f77b7f2dbba902b">iPcMesh::Hide</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Hide this mesh. </p>

</div>
</div>
<a class="anchor" id="a9a5048289df31d088e40f0a1c4d40771"></a><!-- doxytag: member="iPcMesh::IsVisible" ref="a9a5048289df31d088e40f0a1c4d40771" args="() const =0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool <a class="el" href="structiPcMesh.html#a9a5048289df31d088e40f0a1c4d40771">iPcMesh::IsVisible</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const<code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Return true if mesh is visible. </p>

</div>
</div>
<a class="anchor" id="a6e829a0c7fc5f2fa2c3f960793e31d7f"></a><!-- doxytag: member="iPcMesh::MoveMesh" ref="a6e829a0c7fc5f2fa2c3f960793e31d7f" args="(iSector *sector, const csVector3 &amp;pos)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiPcMesh.html#a6e829a0c7fc5f2fa2c3f960793e31d7f">iPcMesh::MoveMesh</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiSector.html">iSector</a> *&#160;</td>
          <td class="paramname"><em>sector</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a> &amp;&#160;</td>
          <td class="paramname"><em>pos</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Convenience function to move the mesh to some sector and position and also update lighting. </p>
<p>If sector specified is 0, sector is not updated. </p>

</div>
</div>
<a class="anchor" id="a2562f38328a7bf1e5ad6decb8aa63fd0"></a><!-- doxytag: member="iPcMesh::MoveMesh" ref="a2562f38328a7bf1e5ad6decb8aa63fd0" args="(iSector *sector, const char *node)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiPcMesh.html#a6e829a0c7fc5f2fa2c3f960793e31d7f">iPcMesh::MoveMesh</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiSector.html">iSector</a> *&#160;</td>
          <td class="paramname"><em>sector</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>node</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Convenience function to move the mesh to some sector and node and also update lighting. </p>
<p>If sector specified is 0, sector is not updated. </p>

</div>
</div>
<a class="anchor" id="a190afeaf6e815f1f1c3e305ccd916b10"></a><!-- doxytag: member="iPcMesh::MoveMesh" ref="a190afeaf6e815f1f1c3e305ccd916b10" args="(iPcMesh *other_mesh, const csVector3 &amp;offset)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiPcMesh.html#a6e829a0c7fc5f2fa2c3f960793e31d7f">iPcMesh::MoveMesh</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structiPcMesh.html">iPcMesh</a> *&#160;</td>
          <td class="paramname"><em>other_mesh</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a> &amp;&#160;</td>
          <td class="paramname"><em>offset</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Convenience function to move the mesh to a position relative to some other mesh, and also update lighting. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">other_mesh</td><td>pcmesh that will be used for base position. </td></tr>
    <tr><td class="paramname">offset</td><td>offset from the base mesh in that mesh local coordinates. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a1e85edbbe5f2d9b1918a2153afc54990"></a><!-- doxytag: member="iPcMesh::SetAction" ref="a1e85edbbe5f2d9b1918a2153afc54990" args="(const char *actionName, bool reset=false)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiPcMesh.html#a1e85edbbe5f2d9b1918a2153afc54990">iPcMesh::SetAction</a> </td>
          <td>(</td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>actionName</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>reset</em> = <code>false</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Convenience function to set an 'action' for the mesh. </p>
<p>This only works for 3D sprites. For other mesh objects nothing will happen. </p>

</div>
</div>
<a class="anchor" id="a2ebf79681aa9fafa6e9fafdc1e8b42b2"></a><!-- doxytag: member="iPcMesh::SetAnimation" ref="a2ebf79681aa9fafa6e9fafdc1e8b42b2" args="(const char *actionName, bool cycle, float weight=1.0, float fadein=0.1, float fadeout=0.1, bool reset=false)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiPcMesh.html#a2ebf79681aa9fafa6e9fafdc1e8b42b2">iPcMesh::SetAnimation</a> </td>
          <td>(</td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>actionName</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>cycle</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>weight</em> = <code>1.0</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>fadein</em> = <code>0.1</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>fadeout</em> = <code>0.1</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>reset</em> = <code>false</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Function to set an 'action' for the mesh. </p>
<p>Works for cal3d, spr3d and genmeshskelanim, but note not all mesh objects support the same feature set. </p>

</div>
</div>
<a class="anchor" id="a2ab3432fdc392c0efc5b15a92a24c084"></a><!-- doxytag: member="iPcMesh::SetMesh" ref="a2ab3432fdc392c0efc5b15a92a24c084" args="(const char *factname, const char *filename)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool <a class="el" href="structiPcMesh.html#a2ab3432fdc392c0efc5b15a92a24c084">iPcMesh::SetMesh</a> </td>
          <td>(</td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>factname</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>filename</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Set the mesh filename to use. </p>
<p>Returns false on failure. Note that this filename can refer to a mesh factory file or a library file containing a mesh factory. If 'filename' is not given (i.e. 0) then it is assumed the factory is already loaded in memory. </p>

</div>
</div>
<a class="anchor" id="aeb16f4efc93224b58d8cbc5b52c981b4"></a><!-- doxytag: member="iPcMesh::SetMesh" ref="aeb16f4efc93224b58d8cbc5b52c981b4" args="(iMeshWrapper *mesh, bool do_remove=false)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiPcMesh.html#a2ab3432fdc392c0efc5b15a92a24c084">iPcMesh::SetMesh</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiMeshWrapper.html">iMeshWrapper</a> *&#160;</td>
          <td class="paramname"><em>mesh</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>do_remove</em> = <code>false</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Set the mesh to use directly. </p>
<p>It is normally not recommended to use this function directly. <a class="el" href="structiPcRegion.html" title="The representation of a region.">iPcRegion</a> will use it for its dummy entities. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">mesh</td><td>a pointer to an <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiMeshWrapper.html">iMeshWrapper</a> that will be attached to the pcmesh. </td></tr>
    <tr><td class="paramname">do_remove</td><td>if true then this pcmesh will remove the mesh on destruction. By default this will not happen if you use <a class="el" href="structiPcMesh.html#a2ab3432fdc392c0efc5b15a92a24c084" title="Set the mesh filename to use.">SetMesh()</a> on an already existing mesh. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a91fc60c23d84087bfccfe0f76f649189"></a><!-- doxytag: member="iPcMesh::SetPath" ref="a91fc60c23d84087bfccfe0f76f649189" args="(const char *path)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiPcMesh.html#a91fc60c23d84087bfccfe0f76f649189">iPcMesh::SetPath</a> </td>
          <td>(</td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>path</em></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Set the path to use. </p>
<p>If this is not done then the filename in <a class="el" href="structiPcMesh.html#a2ab3432fdc392c0efc5b15a92a24c084" title="Set the mesh filename to use.">SetMesh()</a> will be used alone. Otherwise this path is used to temporarily set the current VFS dir while loading (which will be restored afterwards) and the filename in <a class="el" href="structiPcMesh.html#a2ab3432fdc392c0efc5b15a92a24c084" title="Set the mesh filename to use.">SetMesh()</a> is used relative to that. Note that this must be called before <a class="el" href="structiPcMesh.html#a2ab3432fdc392c0efc5b15a92a24c084" title="Set the mesh filename to use.">SetMesh()</a>. </p>

</div>
</div>
<a class="anchor" id="a1dd7280f6eb19bfcfafb47e098b86182"></a><!-- doxytag: member="iPcMesh::SetReverseAction" ref="a1dd7280f6eb19bfcfafb47e098b86182" args="(bool reverse=true)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiPcMesh.html#a1dd7280f6eb19bfcfafb47e098b86182">iPcMesh::SetReverseAction</a> </td>
          <td>(</td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>reverse</em> = <code>true</code></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Convenience function to set an 'action' to be reversed for the mesh. </p>
<p>This only works for 3D sprites. For other mesh objects nothing will happen. </p>

</div>
</div>
<a class="anchor" id="a63106a14cd825a75e85ff00e2cd8e3a9"></a><!-- doxytag: member="iPcMesh::Show" ref="a63106a14cd825a75e85ff00e2cd8e3a9" args="()=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiPcMesh.html#a63106a14cd825a75e85ff00e2cd8e3a9">iPcMesh::Show</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Show this mesh. </p>

</div>
</div>
<hr/>The documentation for this struct was generated from the following file:<ul>
<li>propclass/<a class="el" href="mesh_8h_source.html">mesh.h</a></li>
</ul>
</div><!-- contents -->
<hr size="1"><address><small>Generated for CEL: Crystal Entity Layer 2.0 by 
<a href="http://www.doxygen.org/index.html">doxygen</a> 1.7.6.1 
</small></address> </div></body> </html>
